#pragma once
#include "Thing.h"
#include "Header.h"

class GameOver :
	public Thing
{
private:
	SDL_Surface *gameover;
	SDL_Rect gameOverTarget;
	SDL_Texture * gameOverTexture;
	SDL_Color textColor;

	SDL_Surface *nochmal;
	SDL_Rect nochmalTarget;
	SDL_Texture *nochmalTexture;

	SDL_Surface *aufhoern;
	SDL_Rect aufhoernTarget;
	SDL_Texture * aufhoernTexture;

	SDL_Surface *congrats;
	SDL_Rect congratsTarget;
	SDL_Texture * congratsTexture;

	SDL_Surface *savior;
	SDL_Rect saviorTarget;
	SDL_Texture * saviorTexture;

	SDL_Surface *NewHighScoreEnterNameSurface;
	SDL_Rect NewHighScoreEnterNameTarget;
	SDL_Texture * NewHighScoreEnterNameTexture;

	SDL_Surface *NameFieldSurface;
	SDL_Rect NameFieldTarget;
	SDL_Texture * NameFieldTexture;

	SDL_Surface *BlackSurface;
	SDL_Texture *BlackTexture;

	int mouseX;
	int mouseY;
	bool waiting = true;
	std::string newName;

	Mix_Music *Requiem;
	

public:
	virtual void initiate(int i) {
		SDL_FreeSurface(gameover);
		SDL_DestroyTexture(gameOverTexture);
		textColor = { 255, 255, 255 };
		gameover = TTF_RenderText_Solid(font, "GAME OVER", textColor);
		gameOverTexture = SDL_CreateTextureFromSurface(renderer, gameover);
		gameOverTarget.x = 300; gameOverTarget.y = 250; gameOverTarget.h = 80; gameOverTarget.w = 400;
		
		SDL_FreeSurface(nochmal);
		SDL_DestroyTexture(nochmalTexture);
		nochmal = TTF_RenderText_Solid(font, "NOCHMAL", textColor);
		nochmalTexture = SDL_CreateTextureFromSurface(renderer, nochmal);
		nochmalTarget.x = 100; nochmalTarget.y = 510; nochmalTarget.h = 80; nochmalTarget.w = 200;

		SDL_FreeSurface(aufhoern);
		SDL_DestroyTexture(aufhoernTexture);
		aufhoern = TTF_RenderText_Solid(font, "ENDE", textColor);
		aufhoernTexture = SDL_CreateTextureFromSurface(renderer, aufhoern);
		aufhoernTarget.x = 700; aufhoernTarget.y = 510; aufhoernTarget.h = 80; aufhoernTarget.w = 200;

		SDL_FreeSurface(congrats);
		SDL_DestroyTexture(congratsTexture);
		congrats = TTF_RenderText_Solid(font, "CONGRATULATIONS", textColor);
		congratsTexture = SDL_CreateTextureFromSurface(renderer, congrats);
		congratsTarget.x = 200; congratsTarget.y = 250; congratsTarget.h = 80; congratsTarget.w = 600;

		SDL_FreeSurface(savior);
		SDL_DestroyTexture(saviorTexture);
		savior = TTF_RenderText_Solid(font, "THANK YOU FOR SAVING OUR PLANET!", textColor);
		saviorTexture = SDL_CreateTextureFromSurface(renderer, savior);
		saviorTarget.x = 200; saviorTarget.y = 350; saviorTarget.h = 80; saviorTarget.w = 600;

		SDL_FreeSurface(NewHighScoreEnterNameSurface);
		SDL_DestroyTexture(NewHighScoreEnterNameTexture);
		NewHighScoreEnterNameSurface = TTF_RenderText_Solid(font, "NEW HIGHSCORE! ENTER YOUR NAME: ", textColor);
		NewHighScoreEnterNameTexture = SDL_CreateTextureFromSurface(renderer, NewHighScoreEnterNameSurface);
		NewHighScoreEnterNameTarget.x = 200; NewHighScoreEnterNameTarget.y = 50; NewHighScoreEnterNameTarget.h = 80; NewHighScoreEnterNameTarget.w = 600;

		SDL_FreeSurface(BlackSurface);
		SDL_DestroyTexture(BlackTexture);
		BlackSurface = SDL_LoadBMP("schwarz.bmp");//Player
		BlackTexture = SDL_CreateTextureFromSurface(renderer, BlackSurface);
		
		NameFieldTarget.x = 810; NameFieldTarget.w = 180; NameFieldTarget.y = 50; NameFieldTarget.h = 80;

	}
	virtual void update(int i) {
		newName = "";
		if (Globalgameover == true) {
			Requiem = Mix_LoadMUS("requiemPhaserBass.wav");
			Mix_FadeInMusic(Requiem, -1, 2000);
			//SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
			//SDL_RenderClear(renderer);
			if (durchgeschafft == false) SDL_RenderCopy(renderer, gameOverTexture, NULL, &gameOverTarget);
			
			else if (durchgeschafft == true) {
				SDL_RenderCopy(renderer, congratsTexture, NULL, &congratsTarget);
				SDL_RenderCopy(renderer, saviorTexture, NULL, &saviorTarget);
			}

			if (newHighScore == true) {
				SDL_RenderCopy(renderer, NewHighScoreEnterNameTexture, NULL, &NewHighScoreEnterNameTarget);
				SDL_StartTextInput();
			}
			SDL_RenderCopy(renderer, nochmalTexture, NULL, &nochmalTarget);
			SDL_RenderCopy(renderer, aufhoernTexture, NULL, &aufhoernTarget);
			SDL_RenderPresent(renderer);
			SDL_SetRelativeMouseMode(SDL_FALSE);
		
			while (waiting == true) {
				while (SDL_PollEvent(&event) != 0) {
					switch (event.type)
					{
					case SDL_MOUSEBUTTONDOWN:
						SDL_GetMouseState(&mouseX, &mouseY);
						if (mouseX >= 700 && mouseX <= 900 && mouseY >= 510 && mouseY <= 590) {
							game = false;
							waiting = false;
							break;
						}
						if (mouseX >= 100 && mouseX <= 300 && mouseY >= 510 && mouseY <= 590) {
							restart = true;
							waiting = false;

							SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
							SDL_RenderClear(renderer);//
							break;
						}
						if (newHighScore == true) {

					case SDL_KEYDOWN:
						switch (event.key.keysym.sym) {
						case SDLK_BACKSPACE:
							if (newName != "") newName.pop_back(); // = newName.substr(0, newName.length() - 1);
							SDL_FreeSurface(NameFieldSurface);
							SDL_DestroyTexture(NameFieldTexture);
							SDL_RenderCopy(renderer, BlackTexture, NULL, &NameFieldTarget);
							NameFieldSurface = TTF_RenderText_Blended_Wrapped(font, newName.c_str(), textColor, 100);
							NameFieldTexture = SDL_CreateTextureFromSurface(renderer, NameFieldSurface);
							SDL_RenderCopy(renderer, NameFieldTexture, NULL, &NameFieldTarget);
							SDL_RenderPresent(renderer);
							
							break;
						}
						break;

					case SDL_TEXTINPUT: 
						newName = newName + event.text.text;
						globalNewName = newName;
						SDL_FreeSurface(NameFieldSurface);
						SDL_DestroyTexture(NameFieldTexture);
						SDL_RenderCopy(renderer, BlackTexture, NULL, &NameFieldTarget);
						NameFieldSurface = TTF_RenderText_Blended_Wrapped(font, newName.c_str(), textColor,100);
						NameFieldTexture = SDL_CreateTextureFromSurface(renderer, NameFieldSurface);
						SDL_RenderCopy(renderer, NameFieldTexture, NULL, &NameFieldTarget);
						SDL_RenderPresent(renderer);
						break;
						}
						break;
					}
				}
			}
			Mix_HaltMusic();
			Mix_FreeMusic(Requiem);
			Globalgameover = false;
			waiting = true;
			playerHit = false;
			SDL_StopTextInput();
		}
	}
	virtual void destroy(int i) {
		SDL_FreeSurface(gameover);
		SDL_DestroyTexture(gameOverTexture);
		SDL_FreeSurface(nochmal);
		SDL_DestroyTexture(nochmalTexture);
		SDL_FreeSurface(aufhoern);
		SDL_DestroyTexture(aufhoernTexture);
		SDL_FreeSurface(congrats);
		SDL_DestroyTexture(congratsTexture);
		SDL_FreeSurface(savior);
		SDL_DestroyTexture(saviorTexture);
		SDL_FreeSurface(savior);
		SDL_DestroyTexture(saviorTexture);
		SDL_FreeSurface(NewHighScoreEnterNameSurface);
		SDL_DestroyTexture(NewHighScoreEnterNameTexture);
		SDL_FreeSurface(BlackSurface);
		SDL_DestroyTexture(BlackTexture);
	}
	GameOver()
	{
	}
	~GameOver()
	{
	}
};

