#pragma once
#include "Thing.h"
#include "Header.h"

class HISCORE :
	public Thing
{
private:
	std::multimap <int, std::string> HISCOREMAP;
	int i;
	bool initiated = false;
	std::string LINES[10];
	std::string line;
	std::string stringnameArray[5];
	std::string KEYSTRING;
	std::string stringkeyArray[5];
	std::string NAMESTRING;
	int INTkey[5];
	std::ifstream ScoreStream;
	std::ifstream NamesStream;

public:
	virtual void initiate(int i) {
		if (initiated == false) {
			ScoreStream.open("scores.csv");
			if (ScoreStream.is_open())
			{
				int count = 0;
				while (getline(ScoreStream, KEYSTRING, ',')) {
					stringkeyArray[count] = KEYSTRING;
					count = count + 1;
				}
				ScoreStream.close();
			}
			NamesStream.open("names.csv");
			if (NamesStream.is_open()) {
				int count = 0;
				while (getline(NamesStream, NAMESTRING, ',')) {
					stringnameArray[count] = NAMESTRING;
					count = count + 1;
				}
				NamesStream.close();
			}

			//THE SCORES ARRAY IS CONVERTED TO AN INT ARRAY THEN SCORES AND NAMES ARE PUT IN A MULTIMAP
			//KEY IS THE SCORE, NAMES ARE THE VALUE. MULTIMAP ALWAYS SORTS ITSELF AUTOMATICALLY WHEN BUILT AND PERMITS THE SAME KEY TWICE, 
			//THAT ALLOWS FOR TWO PEOPLE WITH THE SAME HI-SCORE, EXACTLY WHAT WE NEED
			for (int i = 0; i < 5; i = i++) {
				INTkey[i] = atoi(stringkeyArray[i].c_str());
				HISCOREMAP.insert(make_pair(INTkey[i], stringnameArray[i]));
			}
			globalHISCOREMAP = HISCOREMAP;
			lowestHighScore = HISCOREMAP.begin()->first;
		}
		initiated = true;
	}
	virtual void update(int i) {
		if (newHighScore == true) {
			//NEW SCORE AND NAME IS TAKEN INTO THE MULTIMAP AND LOWEST PAIR IS DELETED 
			std::multimap<int, std::string>::reverse_iterator rit;
			
			//LOGIC FOR GETTING NEW HIGH SCORE AND ENTERING NAME
			std::string newName;
			newName = globalNewName;

			std::multimap<int, std::string>::iterator it;
			if (score >= HISCOREMAP.begin()->first) {
				it = HISCOREMAP.begin();
				HISCOREMAP.erase(it);
				HISCOREMAP.insert(std::make_pair(score, newName));
			}

			for (rit = HISCOREMAP.rbegin(); rit != HISCOREMAP.rend(); ++rit) {
				std::cout << rit->first << " => " << rit->second << '\n';
			}

			//MULTIMAP NAMES ARE ADDED UP TO ONE STRING AND DELIMITED BY COMMA
			std::string newNamestring;
			for (rit = HISCOREMAP.rbegin(); rit != HISCOREMAP.rend(); ++rit) { //REVERSE ITERATING: STARTS WITH HIGHEST SCORE
				std::string addName;
				addName = rit->second;
				newNamestring = newNamestring + addName + ","; // (rit->second).c_str; // << " => " << rit->second << '\n';
			}
			//cout << newNamestring;
			//THAT STRING IS WRITTEN INTO THE NAME FILE, REPLACING THE ORIGINAL		
			std::ofstream newNames;
			newNames.open("names.csv");
			newNames << newNamestring;
			newNames.close();

			//SAME STORY FOR SCORES
			std::string newScorestring;
			for (rit = HISCOREMAP.rbegin(); rit != HISCOREMAP.rend(); ++rit) {
				std::string addScore;
				addScore = std::to_string(rit->first); //ints reconversion to string
				newScorestring = newScorestring + addScore + ",";
			}
			//cout << newScorestring;
			std::ofstream newScores;
			newScores.open("scores.csv");
			newScores << newScorestring;
			newScores.close();
			//NEXT TIME THE PROGRAM RUNS, YOU WILL HAVE THE NAMES AND SCORES FROM THE LAST SESSION.
		}
		newHighScore = false;
		globalHISCOREMAP = HISCOREMAP;
	}
	
	HISCORE()
	{
	}

	~HISCORE()
	{
	}
};

