
#include "Header.h"
#include "barriers.h"
#include "Thing.h"
#include "Player.h"
#include "littleGrey.h"
#include "tripod.h"
#include "Tako.h"
#include "PlayerLaser.h"
#include "Fragment.h"
#include "EnemyLaser.h"
#include "Explosion.h"
#include "UFO.h"
#include "Score.h"
#include "ScoreFigure.h"
#include "Lives.h"
#include "LivesFigure.h"
#include "GameOver.h"
#include "NextStage.h"
#include "youdeadSAD.h"
#include "pause.h"
#include "Start.h"
#include "FirstStage.h"
#include "SoundFX.h"
#include "HISCORE.h"

int main(int argc, char ** argv)
{
	//global initiation
	Thing::go = false;
	Thing::initWindow(Thing::window);
	Thing::initRenderer(Thing::renderer);
	TTF_Init();
	Thing::initFont(Thing::font);
	Thing::initBorders(Thing::RightBorder, Thing::LeftBorder);
	Thing::initbarrierRessource(Thing::barrierSurface, Thing::barrierTexture, Thing::barrierSource);
	Thing::initlittleGrey(Thing::littleGreySurface, Thing::littleGreyTexture);
	Thing::initTripod(Thing::tripodBodySurface, Thing::tripodBodyTexture);
	Thing::inittakoRessource(Thing::takoSurface, Thing::takoTexture);
	Thing::initexplosionRessource(Thing::explosionSurface, Thing::explosionTexture);
	//the properly object oriented stuff, this time I wanted to implement update methods to make main less messy
	Thing *things[2371]; //INSTANCES ARE POINTERS, THEN MAXIMUM NUMBER OF THINGS ON SCREEN. EVERYTHING BELOW IS VERY RIGIDLY NUMBERED, TAKE NOTES WHEN CHANGING STUFF!
	barriers barrierInstance[380];//THE WALLS
	for (i = 0; i<380; i++) things[i] = &barrierInstance[i]; //Instances of things are made references to instances of subclasses
	Player player;
	player.initPlayer(player.PlayerSurface, player.PlayerTexture);
	things[380] = &player;//Here the player's spaceship 
	//enemies instantiated then added to things too
	littleGrey littleGrey[11];
	for (i = 0; i < 11; i++) things[i + 381] = &littleGrey[i];
	tripod tripod[22];
	for (i = 0; i < 22; i++) things[i + 392] = &tripod[i];
	Tako tako[22];
	for (i = 0; i < 22; i++) things[i + 414] = &tako[i];
	PlayerLaser laser;
	things[436] = &laser; //Here laser beam for player
	UFO ufo; //space ship that randomly appears 
	ufo.initUFO(Thing::UFOSurface, Thing::UFOTexture);
	things[437] = &ufo;
	Fragment fragment[1810];//THIS IS PREPARING THE PIECES FOR WHEN ENEMIES EXPLODE 
	for (i = 0; i < 1810; i++) things[i + 438] = &fragment[i];
	//SLOTS FOR ENEMY LASERS
	EnemyLaser enemyLaser[55];
	for (i = 0; i < 55; i++) things[i + 2248] = &enemyLaser[i];
	//SLOTS FOR ENEMY EXPLOSIONS
	Explosion explosion[56];
	for (i = 0; i < 56; i++) things[i + 2303] = &explosion[i];
	//TEXT AND NUMBERS THAT APPEAR ON SCREEN
	Score SCORE; 
	things[2359] = &SCORE;
	ScoreFigure scoreFigure;
	things[2360] = &scoreFigure;
	Lives LIVES;
	things[2361] = &LIVES;
	LivesFigure livesFigure;
	things[2362] = &livesFigure;
	GameOver gameover;
	things[2363] = &gameover;
	NextStage nextstage;
	things[2364] = &nextstage;
	youdeadSAD youdeadsad;
	things[2365] = &youdeadsad;
	pause PAUSE;
	things[2366] = &PAUSE;
	Start START;
	things[2367] = &START;
	FirstStage FIRSTSTAGE;
	things[2368] = &FIRSTSTAGE;
	SoundFX SOUNDFX;
	things[2369] = &SOUNDFX;
	HISCORE hiscoreInstance;
	things[2370] = &hiscoreInstance;
	for (i = 0; i < maxNumberThings; i++) things[i]->initiate(i);	//EVERYTHING INITIATED IN ONE SINGLE CALL BEFORE ENTERING GAME LOOP. BODACIOUS.
	things[2367]->update(2367);//START SCREEN
	SDL_RenderClear(Thing::renderer);
	things[2368]->update(2368);//STAGE 1 ANNOUNCEMENT
	Thing::Globalfirststage = false;
	//GAME LOOP
	while (Thing::game == true) {
		Thing::begin = std::chrono::steady_clock::now();
		SDL_SetRenderDrawColor(Thing::renderer, 0, 0, 0, 255);
		SDL_RenderClear(Thing::renderer);
		if (Thing::restart == true) {
			UFO_[0] = SILENCE_PUSH;
			for (int i = 0; i < 33; i++) {
				FX_QUEUE[i] = SILENCE_PUSH;
			}
		}
		Thing::restartVars(Thing::moveTreshold, Thing::EnemiesLeft, Thing::lives, Thing::score, Thing::levelup, Thing::stage, Thing::right, Thing::left, Thing::down, Thing::wentDown, Thing::nextDownthenLeft, Thing::nextDownthenRight, Thing::durchgeschafft, Thing::startScreen, Thing::Globalgameover);
		if (Thing::restart == true) {
			SDL_RenderClear(Thing::renderer);
			things[2367]->update(2367);//START SCREEN
			SDL_RenderClear(Thing::renderer);
			Thing::Globalfirststage = true;
			things[2368]->update(2368);//STAGE 1 ANNOUNCEMENT
			Thing::Globalfirststage = false;
			SDL_RenderClear(Thing::renderer);
			for (i = 0; i < maxNumberThings; i++) things[i]->initiate(i);
			player.extraLife = false;
			Thing::restart = false;
		}
		
		//INPUT HANDLING
		if (Thing::Globalfirststage == false && Thing::Globalnextstage == false && Thing::playerHit == false && Thing::Globalgameover == false && Thing::startScreen == false) {

			while (SDL_PollEvent(&Thing::event) != 0) {
				SDL_SetRelativeMouseMode(SDL_TRUE);
				switch (Thing::event.type)
				{
				case SDL_QUIT:
					Thing::game = false;
					break;

				case SDL_MOUSEMOTION:
					if (Thing::demoMode == true) {
						Thing::restart = true;
						Thing::demoMode = false;
					}
					SDL_GetMouseState(&player.PlayerPosX, &player.PlayerPosY);
					if (player.PlayerPosX < 0) player.PlayerPosX = 30;
					if (player.PlayerPosX > 1000) player.PlayerPosX = 975;
					if (player.PlayerPosY != 540) player.PlayerPosY = 540;
					break;
				case SDL_MOUSEBUTTONDOWN:
					if (Thing::PlayershotFired == false) {
						Thing::PlayershotFired = true;
						for (int z = 0; z < 32; z++) {
							if (FX_QUEUE[z] == SILENCE_PUSH) {
								FX_QUEUE[z] = PLAYERLASER_PUSH;
								break;
							}
						}
						laser.laserStartX = player.PlayerPosX + 19;
						laser.laserStartY = player.PlayerPosY;
						laser.laserEndX = laser.laserStartX;
						laser.laserEndY = laser.laserStartY; // - 20;
					}
					break;

				case SDL_KEYDOWN:
					switch (Thing::event.key.keysym.sym) {
					case SDLK_LEFT:
						player.PlayerPosX = player.PlayerTarget.x - 10;//(player.PixPerSec)*(Thing::timeDelta/100000000);
						if (player.PlayerPosX < 0) player.PlayerPosX = 30;
						break;
					case SDLK_RIGHT:
						player.PlayerPosX = player.PlayerTarget.x + 10;// (player.PixPerSec)*(Thing::timeDelta / 100000000);

						if (player.PlayerPosX > 1000) player.PlayerPosX = 975;
						if (player.PlayerPosY != 540) player.PlayerPosY = 540;
						break;
					case SDLK_p:
						Thing::Pause = true;
						break;
					case SDLK_SPACE: //STUERZT AB
						if (Thing::PlayershotFired == false) {
							Thing::PlayershotFired = true;
							for (int z = 0; z < 32; z++) {
								if (FX_QUEUE[z] == SILENCE_PUSH) {
									FX_QUEUE[z] = PLAYERLASER_PUSH;
									break;
								}
							}
							laser.laserStartX = player.PlayerPosX + 19;
							laser.laserStartY = player.PlayerPosY;
							laser.laserEndX = laser.laserStartX;
							laser.laserEndY = laser.laserStartY; // - 20;
						}
						break;

					case SDLK_ESCAPE:

						Thing::game = false;
						break;
					}
				}
				break;
			}
		}
		Thing::movement(Thing::left, Thing::right, Thing::down, Thing::wentDown, Thing::nextDownthenLeft, Thing::nextDownthenRight);
		for (i = 0; i < 2371; i++) things[i]->update(i); //Update method, one call for everything. BODACIOUS. 
		 //Below is what happens when you level up or go game over or clear the last stage
		Thing::NextOrGameOver(Thing::GlobalReset, Thing::GlobalResetDone, Thing::EnemiesLeft, Thing::stage, Thing::durchgeschafft, Thing::Globalgameover, Thing::UFO_active, Thing::Globalnextstage);
		if (Thing::Globalnextstage == true)	things[2364]->update(2364); //nextStageMEssage
		if (Thing::GlobalReset == true) for (i = 0; i < maxNumberThings; i++) things[i]->initiate(i);
		Thing::DoReset(Thing::GlobalReset, Thing::levelup, Thing::GlobalResetDone, Thing::EnemiesLeft, Thing::right, Thing::right, Thing::nextDownthenRight, Thing::nextDownthenLeft, Thing::moveTreshold);
		Thing::go = false;
		for (i = 11; i < 22; i++) { //Flags the front line enemies that are allowed to shoot in the next cycle.
			if (tako[i].dead == false) tako[i].front = true;
			else if (tako[i - 11].dead == false) tako[i - 11].front = true;
			else if (tripod[i].dead == false) tripod[i].front = true;
			else if (tripod[i - 11].dead == false) tripod[i - 11].front = true;
			else if (littleGrey[i - 11].dead == false) littleGrey[i - 11].front = true;
		}
		SDL_RenderPresent(Thing::renderer);
		Thing::end = std::chrono::steady_clock::now();
		Thing::timeDelta = std::chrono::duration_cast<std::chrono::nanoseconds>(Thing::end - Thing::begin).count();
		Thing::timeBucket = Thing::timeBucket + 15000000;
		if (Thing::timeDelta >= 15000000) Thing::sleepTime = 0;
		else Thing::sleepTime = (15000000 - Thing::timeDelta)/1000000;
		SDL_Delay(Thing::sleepTime);
		if (Thing::timeBucket >= Thing::moveTreshold) {
			Thing::timeBucket = 0; Thing::go = true;
		}
	}
//	for (i = 0; i < 2371; i++) things[i]->destroy(i); //STUERZT IMMER AB
	Thing::DestroyGlobals(Thing::UFOSurface, Thing::UFOTexture, Thing::littleGreySurface, Thing::littleGreyTexture, Thing::tripodBodySurface, Thing::tripodBodyTexture, Thing::takoSurface, Thing::takoTexture, Thing::barrierSurface, Thing::barrierTexture, Thing::explosionSurface, Thing::explosionTexture, Thing::renderer, Thing::window, Thing::font);
	return 0;
}