#pragma once
#include "Thing.h"
#include "Header.h"
class NextStage :
	public Thing
{
private:
	SDL_Surface *nextstage;
	SDL_Rect nextStageTarget;
	SDL_Texture * nextStageTexture;
	SDL_Color textColor;
	std::string getReady = "GET READY FOR STAGE ";
	std::string stageString;
	const char *STAGE;
	std::chrono::steady_clock::time_point start;
	std::chrono::steady_clock::time_point finish;
	long double timeElapsed = 0;
public:
	virtual void initiate(int i) {
		textColor = { 255, 255, 255 };
		nextStageTarget.x = 300; nextStageTarget.y = 250; nextStageTarget.h = 80; nextStageTarget.w = 400;
	}
	virtual void update(int i) {
		if (Globalnextstage == true && durchgeschafft == false)
		{
			stage = stage + 1;
			if (stage != 1) {//avoid overlaps with the firststage message
				SDL_FreeSurface(nextstage);
				SDL_DestroyTexture(nextStageTexture);
				stageString = getReady + std::to_string(stage);
				STAGE = stageString.c_str();
				nextstage = TTF_RenderText_Solid(font, STAGE, textColor);
				nextStageTexture = SDL_CreateTextureFromSurface(renderer, nextstage);
				SDL_RenderCopy(renderer, nextStageTexture, NULL, &nextStageTarget);
				SDL_RenderPresent(renderer);
				start = std::chrono::steady_clock::now();
				while (true) {
					finish = std::chrono::steady_clock::now();
					timeElapsed = std::chrono::duration_cast<std::chrono::nanoseconds>(finish - start).count();
					if (timeElapsed >= 5000000000) break;
				}
			}
			Globalnextstage = false;
			EnemiesLeft = 55;
			GlobalReset = true;
		}
	}
	virtual void destroy(int i) {
		SDL_FreeSurface(nextstage);
		SDL_DestroyTexture(nextStageTexture);
	}
	NextStage()
	{
	}
	~NextStage()
	{
	}
};

