#include "Thing.h"

SDL_Window *Thing::window;
SDL_Renderer *Thing::renderer;
SDL_Event Thing::event;
void Thing::initWindow(SDL_Window* &window) {
	Thing::window = SDL_CreateWindow("Test", 100, 100, 1000, 600, NULL);
}
void Thing::initRenderer(SDL_Renderer * &renderer) {
	Thing::renderer = SDL_CreateRenderer(Thing::window, -1, 0);
	SDL_SetRenderDrawColor(Thing::renderer, 0, 0, 0, 255);
}
TTF_Font* Thing::font;
void Thing::initFont(TTF_Font* &font) {
	font = TTF_OpenFont("slkscr.ttf", 8);
}
void Thing::initBorders(SDL_Rect &RightBorder, SDL_Rect &LeftBorder) {
	LeftBorder.x = 0; LeftBorder.y = 0; LeftBorder.h = 600; LeftBorder.w = 40;
	RightBorder.x = 960; RightBorder.y = 0; RightBorder.h = 600; RightBorder.w = 40;
}
void Thing::initbarrierRessource(SDL_Surface * &barrierSurface, SDL_Texture * &barrierTexture, SDL_Rect &barrierSource) {
	barrierSurface = SDL_LoadBMP("barrier.bmp"); //barrier
	barrierTexture = SDL_CreateTextureFromSurface(renderer, barrierSurface);
	barrierSource.x = 0; barrierSource.y = 0; barrierSource.w = 10; barrierSource.h = 10;
}
void Thing::initlittleGrey(SDL_Surface * &littleGreySurface, SDL_Texture * &littleGreyTexture) {
	littleGreySurface = SDL_LoadBMP("grau.bmp"); //grau
	SDL_SetColorKey(littleGreySurface, SDL_TRUE, SDL_MapRGB(littleGreySurface->format, 255, 0, 255));
	littleGreyTexture = SDL_CreateTextureFromSurface(renderer, littleGreySurface);
}

void Thing::initTripod(SDL_Surface * &tripodBodySurface, SDL_Texture * &tripodBodyTexture) {
	tripodBodySurface = SDL_LoadBMP("TripodBody.bmp");//TripodBody
	SDL_SetColorKey(tripodBodySurface, SDL_TRUE, SDL_MapRGB(tripodBodySurface->format, 255, 0, 255));
	tripodBodyTexture = SDL_CreateTextureFromSurface(Thing::renderer, tripodBodySurface);
}
void Thing::inittakoRessource(SDL_Surface * &takoSurface, SDL_Texture * &takoTexture) {
	takoSurface = SDL_LoadBMP("black.bmp");//black
	SDL_SetColorKey(takoSurface, SDL_TRUE, SDL_MapRGB(takoSurface->format, 255, 0, 255));
	takoTexture = SDL_CreateTextureFromSurface(Thing::renderer, takoSurface);
}
void Thing::initexplosionRessource(SDL_Surface * &explosionSurface, SDL_Texture * &explosionTexture) {
	explosionSurface = SDL_LoadBMP("explosion.bmp");//explosion
	SDL_SetColorKey(explosionSurface, SDL_TRUE, SDL_MapRGB(explosionSurface->format, 255, 0, 255));
	explosionTexture = SDL_CreateTextureFromSurface(Thing::renderer, explosionSurface);
}
void Thing::DestroyGlobals(SDL_Surface *&UFOSurface, SDL_Texture *&UFOTexture, SDL_Surface* &littleGreySurface, SDL_Texture *&littleGreyTexture, SDL_Surface *&tripodBodySurface, SDL_Texture *&tripodBodyTexture,
	SDL_Surface *&takoSurface, SDL_Texture *&takoTexture, SDL_Surface *&barrierSurface, SDL_Texture *&barrierTexture, SDL_Surface *&explosionSurface, SDL_Texture *&explosionTexture, SDL_Renderer *&renderer, SDL_Window *&window, TTF_Font *&font) {
	SDL_FreeSurface(Thing::UFOSurface);
	SDL_DestroyTexture(Thing::UFOTexture);
	SDL_FreeSurface(Thing::littleGreySurface);
	SDL_DestroyTexture(Thing::littleGreyTexture);
	SDL_FreeSurface(Thing::tripodBodySurface);
	SDL_DestroyTexture(Thing::tripodBodyTexture);
	SDL_FreeSurface(Thing::takoSurface);
	SDL_DestroyTexture(Thing::takoTexture);
	SDL_FreeSurface(Thing::barrierSurface);
	SDL_DestroyTexture(Thing::barrierTexture);
	SDL_FreeSurface(Thing::explosionSurface);
	SDL_DestroyTexture(Thing::explosionTexture);
	SDL_DestroyRenderer(Thing::renderer);
	SDL_DestroyWindow(Thing::window);
	TTF_CloseFont(Thing::font);
	TTF_Quit();
	SDL_Quit();
}
std::multimap <int, std::string> Thing::globalHISCOREMAP;
int Thing::lowestHighScore;
int Thing::stage = 1;
bool Thing::startScreen = true;

//int Thing::maxNumberThings = 2371;

std::chrono::steady_clock::time_point Thing::begin;
std::chrono::steady_clock::time_point Thing::end;
bool Thing::game = true;
bool Thing::Globalgameover = false;
bool Thing::Globalnextstage;
bool Thing::Globalfirststage = true;
bool Thing::GlobalReset = false;
bool Thing::GlobalResetDone = false;
int Thing::score = 0;
int Thing::lives = 3;
long double Thing::timeBucket = 0;
long double Thing::timeDelta = 0;
long double Thing::sleepTime = 0;
int Thing::EnemiesLeft = 55;
bool Thing::Pause;
bool Thing::restart;
bool Thing::durchgeschafft;
bool Thing::newHighScore = false;
std::string Thing::globalNewName;
bool Thing::loadUfo;

bool Thing::go = false;
bool Thing::right = true;
bool Thing::left = false;
bool Thing::down = false;
bool Thing::nextDownthenRight = false;
bool Thing::nextDownthenLeft = false;
bool Thing::wentDown = false;
SDL_Rect Thing::RightBorder;
SDL_Rect Thing::LeftBorder;
long double Thing::moveTreshold = 500000000;
int Thing::levelup = 0;

SDL_Rect Thing::PlayerLaserRect;
bool Thing::PlayershotFired = false;
bool Thing::PlayerlaserCollide = false;

//DEMO MODE STUFF
bool Thing::demoMode = false;
int Thing::GloballaserStartX;
int Thing::GloballaserStartY;
int Thing::GloballaserEndX;
int Thing::GloballaserEndY;

SDL_Rect Thing::enemyLaserRect[55];
int Thing::enemyLaserStartX[55]; int Thing::enemyLaserEndX[55]; int Thing::enemyLaserStartY[55]; int Thing::enemyLaserEndY[55];
bool Thing::enemyLaserActive[55];
bool Thing::playerHit;

//Enemies
SDL_Rect Thing::UFOTarget;
SDL_Texture * Thing::UFOTexture;
SDL_Surface * Thing::UFOSurface;
bool Thing::UFO_active;

SDL_Rect Thing::littleGreyTarget[11];
SDL_Texture * Thing::littleGreyTexture;
SDL_Surface * Thing::littleGreySurface;
bool Thing::littleGreyDead[11];

SDL_Rect Thing::tripodBodyTarget[22];//Body mit Beinen nach unten erweitern
SDL_Texture * Thing::tripodBodyTexture;
SDL_Surface * Thing::tripodBodySurface;

SDL_Rect Thing::takoTarget[22];
SDL_Texture * Thing::takoTexture;
SDL_Surface * Thing::takoSurface;

//the wall (breaks when hit by player or enemy laser, game over when enemy collides with it)  
SDL_Rect Thing::BarrierTarget[380];
SDL_Texture * Thing::barrierTexture;
SDL_Surface * Thing::barrierSurface;
SDL_Rect Thing::barrierSource;

//when hit: explode and burst into pieces
SDL_Rect Thing::explosionTarget[56];
bool Thing::explosionActive[56];
SDL_Texture *Thing::explosionTexture;
SDL_Surface *Thing::explosionSurface;
SDL_Rect Thing::FragmentTarget[1810];//1809
int Thing::LegStartX[66]; int Thing::LegEndX[66]; int Thing::LegStartY[66]; int Thing::LegEndY[66];
bool Thing::fragmentActive[1810];//1809

void Thing::movement(bool &left, bool &right, bool &down, bool &wentDown, bool &nextDownthenLeft, bool&nextDownthenRight) {
	if (Thing::nextDownthenLeft == true && Thing::wentDown == false) {
		Thing::left = false;
		Thing::right = false;
		Thing::down = true;
	}
	else if (Thing::nextDownthenLeft == true && Thing::wentDown == true) {
		Thing::right = false;
		Thing::down = false;
		Thing::left = true;
		Thing::nextDownthenLeft = false;
		Thing::wentDown = false;
	}
	else if (Thing::nextDownthenRight == true && Thing::wentDown == false) {
		Thing::right = false;
		Thing::left = false;
		Thing::down = true;
	}
	else if (Thing::nextDownthenRight == true && Thing::wentDown == true) {
		Thing::left = false;
		Thing::down = false;
		Thing::right = true;
		Thing::nextDownthenRight = false;
		Thing::wentDown = false;
	}
};

void Thing::NextOrGameOver(bool &GlobalReset, bool &GlobalResetDone, int &EnemiesLeft, int &stage, bool &durchgeschafft,
	bool &Globalgameover, bool &UFO_active, bool &Globalnextstage) {
	if (Thing::GlobalResetDone = true) {
		Thing::GlobalReset = false;
		Thing::GlobalResetDone = false;
	}
	
	if (Thing::EnemiesLeft == 0) {
		if (Thing::stage == 6) {
			Thing::durchgeschafft = true;
			Thing::Globalgameover = true;
			Thing::UFO_active = false;
			Thing::Globalnextstage = false;
		}
		else {
			Thing::Globalnextstage = true;
			Thing::UFO_active = false;
		}
	}
}

void Thing::DoReset(bool GlobalReset, int &levelup, bool &GlobalResetDone, int &EnemiesLeft, bool &right, bool &left, bool &nextDownthenRight, bool&nextDownthenLeft, long double &moveTreshold) {
	// //message for next stage
	if (Thing::GlobalReset == true) {// Here's the flow: all enemies dead (Enemies left == 0) sets Globalnextstage to true.
		Thing::levelup = Thing::levelup + 22; //NextStage takes a break, then resets the kill count, resets movementtreshold and sets GlobalReset to true. 
		//for (int i = 0; i < 2371; i++) things[i]->initiate(i); //GlobalReset meets the condition here to the left that reinitiates the wall and 
															  //the enemies (enemies with with an increment in Y, that is levelup
		Thing::GlobalResetDone = true; // GlobalResetDone is the trigger to the condition that resets the reset flags, up there at the beginning
		Thing::EnemiesLeft = 55;
		Thing::right = true;
		Thing::left = false;
		Thing::nextDownthenRight = false;
		Thing::nextDownthenLeft = false;
		Thing::moveTreshold = 500000000;
	}
}

void Thing::restartVars(long double &moveTreshold, int &EnemiesLeft, int&globalLives, int &globalScore, int &levelup, int &stage, bool&right, bool&left, bool&down, bool&wentDown, bool&nextDownthenLeft, bool&nextDownthenRight, bool &durchgeschafft, bool &startScreen, bool &GlobalGameover){
	if (Thing::restart == true) {
		Thing::moveTreshold = 500000000;
		Thing::EnemiesLeft = 55;
//		Thing::lastSoundSlot = 0;
		Thing::lives = 3;
		Thing::score = 0;
		Thing::levelup = 0;
		Thing::stage = 1;
		Thing::right = true;
		Thing::left = false;
		Thing::down = false;
		Thing::wentDown = false;
		Thing::nextDownthenLeft = false;
		Thing::nextDownthenRight = false;
		Thing::durchgeschafft = false;
		Thing::startScreen = true;
		Thing::Globalgameover = false;
	}
}


//int Thing::lastSoundSlot = 0;
/*enum Thing::FX {
	ENEMYEXPLOSION_PUSH,
	ENEMYLASER_PUSH,
	PLAYERLASER_PUSH,
	PLAYEREXPLOSION_PUSH,
	BARRIEREXPLOSION_PUSH,
	UFO_PUSH,
	SILENCE_PUSH
}; */


